% JAC     numerical Jacobian using forward differences
%         J=jac(f,x) returns the Jacobian of f at x to approximately 6 digits
%         f: usually a .M function to be evaluated as feval(f,x)
%         May also be an expression involving x.
function J=jac(f_,x)
% "103" may be a bug in Octave 2.1.40 or a new feature
f_is_Mfile=exist(f_)==2 || exist(f_)==5 || exist(f_)==103;
if f_is_Mfile, f0=feval(f_,x); else f0=eval(f_); end
J=zeros(length(f0),length(x)); del=1E-5;
for i=1:length(x), y=x(i); x(i)=x(i)+del; 
  if f_is_Mfile, J(:,i)=(feval(f_,x)-f0)/del; else J(:,i)=(eval(f_)-f0)/del; end
  x(i)=y; 
end
